# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetConfigurationGroupResult',
    'AwaitableGetConfigurationGroupResult',
    'get_configuration_group',
    'get_configuration_group_output',
]

@pulumi.output_type
class GetConfigurationGroupResult:
    """
    A collection of values returned by getConfigurationGroup.
    """
    def __init__(__self__, description=None, devices=None, feature_profile_ids=None, feature_versions=None, id=None, name=None, solution=None, topology_devices=None, topology_site_devices=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if devices and not isinstance(devices, list):
            raise TypeError("Expected argument 'devices' to be a list")
        pulumi.set(__self__, "devices", devices)
        if feature_profile_ids and not isinstance(feature_profile_ids, list):
            raise TypeError("Expected argument 'feature_profile_ids' to be a list")
        pulumi.set(__self__, "feature_profile_ids", feature_profile_ids)
        if feature_versions and not isinstance(feature_versions, list):
            raise TypeError("Expected argument 'feature_versions' to be a list")
        pulumi.set(__self__, "feature_versions", feature_versions)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if solution and not isinstance(solution, str):
            raise TypeError("Expected argument 'solution' to be a str")
        pulumi.set(__self__, "solution", solution)
        if topology_devices and not isinstance(topology_devices, list):
            raise TypeError("Expected argument 'topology_devices' to be a list")
        pulumi.set(__self__, "topology_devices", topology_devices)
        if topology_site_devices and not isinstance(topology_site_devices, int):
            raise TypeError("Expected argument 'topology_site_devices' to be a int")
        pulumi.set(__self__, "topology_site_devices", topology_site_devices)

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        Description
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def devices(self) -> Sequence['outputs.GetConfigurationGroupDeviceResult']:
        """
        List of devices
        """
        return pulumi.get(self, "devices")

    @property
    @pulumi.getter(name="featureProfileIds")
    def feature_profile_ids(self) -> Sequence[builtins.str]:
        """
        List of feature profile IDs
        """
        return pulumi.get(self, "feature_profile_ids")

    @property
    @pulumi.getter(name="featureVersions")
    def feature_versions(self) -> Sequence[builtins.str]:
        """
        List of all associated feature versions
        """
        return pulumi.get(self, "feature_versions")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The id of the object
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the configuration group
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def solution(self) -> builtins.str:
        """
        Type of solution
        """
        return pulumi.get(self, "solution")

    @property
    @pulumi.getter(name="topologyDevices")
    def topology_devices(self) -> Sequence['outputs.GetConfigurationGroupTopologyDeviceResult']:
        """
        List of topology device types
        """
        return pulumi.get(self, "topology_devices")

    @property
    @pulumi.getter(name="topologySiteDevices")
    def topology_site_devices(self) -> builtins.int:
        """
        Number of devices per site
        """
        return pulumi.get(self, "topology_site_devices")


class AwaitableGetConfigurationGroupResult(GetConfigurationGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetConfigurationGroupResult(
            description=self.description,
            devices=self.devices,
            feature_profile_ids=self.feature_profile_ids,
            feature_versions=self.feature_versions,
            id=self.id,
            name=self.name,
            solution=self.solution,
            topology_devices=self.topology_devices,
            topology_site_devices=self.topology_site_devices)


def get_configuration_group(id: Optional[builtins.str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetConfigurationGroupResult:
    """
    This data source can read the Configuration Group .

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_configuration_group(id="f6b2c44c-693c-4763-b010-895aa3d236bd")
    ```


    :param builtins.str id: The id of the object
    """
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdwan:index/getConfigurationGroup:getConfigurationGroup', __args__, opts=opts, typ=GetConfigurationGroupResult).value

    return AwaitableGetConfigurationGroupResult(
        description=pulumi.get(__ret__, 'description'),
        devices=pulumi.get(__ret__, 'devices'),
        feature_profile_ids=pulumi.get(__ret__, 'feature_profile_ids'),
        feature_versions=pulumi.get(__ret__, 'feature_versions'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        solution=pulumi.get(__ret__, 'solution'),
        topology_devices=pulumi.get(__ret__, 'topology_devices'),
        topology_site_devices=pulumi.get(__ret__, 'topology_site_devices'))
def get_configuration_group_output(id: Optional[pulumi.Input[builtins.str]] = None,
                                   opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetConfigurationGroupResult]:
    """
    This data source can read the Configuration Group .

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_configuration_group(id="f6b2c44c-693c-4763-b010-895aa3d236bd")
    ```


    :param builtins.str id: The id of the object
    """
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdwan:index/getConfigurationGroup:getConfigurationGroup', __args__, opts=opts, typ=GetConfigurationGroupResult)
    return __ret__.apply(lambda __response__: GetConfigurationGroupResult(
        description=pulumi.get(__response__, 'description'),
        devices=pulumi.get(__response__, 'devices'),
        feature_profile_ids=pulumi.get(__response__, 'feature_profile_ids'),
        feature_versions=pulumi.get(__response__, 'feature_versions'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        solution=pulumi.get(__response__, 'solution'),
        topology_devices=pulumi.get(__response__, 'topology_devices'),
        topology_site_devices=pulumi.get(__response__, 'topology_site_devices')))
